class Admin::DesignsController < ApplicationController
  require "net/http"
  require "uri"
  require 'zip/zip'

  layout "admin"
  before_filter :authenticate_user!
  before_filter :is_admin?

  def upload_package
    if !params[:design].nil?
    temp_file = Tempfile.new("temp_file")
    original_file = params[:design][:package_file]
      #if original_file.content_type == 'application/zip'
        temp_file.write(original_file.read.force_encoding('UTF-8'))
        temp_file.rewind
        filename = File.basename(original_file.original_filename,".zip")
        unzip_design(temp_file, filename)
      #else
      #  flash[:error] = "Upload file should be in zip format"
      #end
      temp_file.close
    end
  end

  def index
    @designs = Design.all.entries
  end

  def new
    @design = Design.new
  end

  def update
    @design = Design.find(params[:id])
    if @design.update_attributes(params[:design])
      flash[:notice] = "Successfully updated design and tasks."
      redirect_to admin_designs_url(@design)
    else
      render :action => 'edit'
    end
  end

  def edit_file
    @design = Design.find(params[:id])
    filename = params[:filename]
    files = @design.themes + @design.javascripts + @design.images
    file_to_removed = files.find{ |obj|
      obj.file_identifier == filename
    }
    type = file_to_removed._type
    new_file = ""
    Dir.mktmpdir('design_temp'){ |dir|
      temp_file = File.new(dir+'/'+filename,'w+')
      temp_file.write params[:context]
      replace_target = eval("@design.#{type.downcase.pluralize}")
      new_file = replace_target.build(:file => temp_file,:to_save=>true)
      file_to_removed.destroy
      new_file.save
      temp_file.close
    }
    respond_to do |format|
      format.js  {}
    end
  end

  def edit
    @design = Design.find(params[:id])
  end

  def destroy
    @design = Design.find(params[:id])
    @design.destroy
    redirect_to admin_designs_url
  end

  def create
    @design = Design.new(params[:design])
    if @design.save
        flash[:notice] = "Successfully created design and tasks."
        redirect_to admin_designs_url
      else
        render :action => 'new'
      end
  end
  
  protected
  
  def unzip_design(file, zip_name)
    Zip::ZipFile.open(file) { |zip_file|
      design = Design.new.from_json(zip_file.read("#{zip_name}/info.json"))
      Dir.mktmpdir('f_path') { |dir|
        design.build_layout
        themes_entries = []
        javascripts_entries = []
        images_entries = []

        zip_file.entries.each do |entry|
          case (path = entry.to_s)
            when /\A(#{zip_name})\/(default\.css)\z/    #for default css
              filename = File.basename(entry.to_s)
              temp_file = File.new(dir + '/' + filename, 'w+') 
              temp_file.write (zip_file.read entry ).force_encoding('UTF-8')
              default_css = design.build_default_css
              default_css.file = temp_file
              default_css.to_save = true
            when /\A(#{zip_name})\/(reset\.css)\z/    #for reset css
              filename = File.basename(entry.to_s)
              temp_file = File.new(dir + '/' + filename, 'w+') 
              temp_file.write (zip_file.read entry ).force_encoding('UTF-8')
              reset_css = design.build_reset_css
              reset_css.file = temp_file
              reset_css.to_save = true
            when /\A(#{zip_name})\/(layout\.html)\z/    #for layout html
              filename = File.basename(entry.to_s)
              temp_file = File.new(dir + '/' + filename, 'w+') 
              temp_file.write (zip_file.read entry ).force_encoding('UTF-8')
              design.layout.file = temp_file
              design.layout.to_save=true
            when /\A(#{zip_name})\/(themes)\/.*(\.css)\z/   #for themes css
              themes_entries << entry
            when /\A(#{zip_name})\/(javascripts)\/.*(\.js)\z/   #for js
              javascripts_entries << entry
            when /\A(#{zip_name})\/(images)\/.*((\.jpg)|(\.png)|(\.gif))\z/   #for img
              images_entries << entry
          end
        end

        ['themes', 'javascripts', 'images'].each do |type|
          eval("#{type}_entries").each do |entry|
            filename = File.basename entry.to_s
            temp_file = File.new(dir + '/' + filename, 'w+')
            temp_file.write (zip_file.read entry).force_encoding('UTF-8')
            build_and_store = eval("design.#{type}").build
            build_and_store.file = temp_file
            build_and_store.to_save = true
          end
        end
      }
      design.save
    }
  end

end
